您的位置:首页 > 其它

HDU 1969 Pie(二分查找)

2014-07-31 15:25 357 查看
Description

My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This
should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though.

My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is
better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size.

What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different.

Input

One line with a positive integer: the number of test cases. Then for each test case:

---One line with two integers N and F with 1 <= N, F <= 10 000: the number of pies and the number of friends.

---One line with N integers ri with 1 <= ri <= 10 000: the radii of the pies.

Output

For each test case, output one line with the largest possible volume V such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10^(-3).

Sample Input

3
3 3
4 3 3
1 24
5
10 5
1 4 2 3 4 5 6 5 4 2


Sample Output

25.1327
3.1416
50.2655


题目大意:
生日会上,有N个馅饼,要来F个朋友,主人要将这些馅饼分给客人,其中包括主人自己。馅饼不能由两个馅饼拼成,即每一个人分到的馅饼仅来自一个馅饼,不同人的馅饼可以来自不同馅饼。编写程序计算客人可分得馅饼的最大面积。

解题思路:

利用二分法,查找馅饼的面积,直到符合条件。详细思路请看代码及注释。

代码如下:

#include<stdio.h>
#include<math.h>
/*反余弦函数,计算π的值,否则
精度可能不够,结果就会WA*/
#define PI acos(-1.0)
int main()
{
int i,j,t,n,f,num;
/*数组(s[ ])开始储存馅饼的半径,后来储存馅
饼的面积即体积,因为馅饼高是1,。注意不可用
半径进行分馅饼,因为半径与面积不等价*/
double sum,low,high,mid,s[10005];
scanf("%d",&t);
while(t--)
{
scanf("%d%d",&n,&f);
for(sum=0,i=0;i<n;i++)
{
scanf("%lf",&s[i]);
//计算馅饼的面积
s[i]=s[i]*s[i]*PI;
//计算馅饼的面积和
sum=sum+s[i];
}
//二分法查找
low=0.0;
//理论上每个人可以得到馅饼的最大面积
high=sum/(f+1);
//结果保留四位小数,因此high与low的差小于1e-5即可
while(fabs(high-low)>1e-5)
{
mid=(low+high)/2;
for(i=0,num=0;i<n;i++)
{
//累加按mid的面积可分出馅饼的数量
num=num+(int)(s[i]/mid);
}
//如果数量大于人数,还可分再大些
if(num>=f+1)
low=mid;
//如果数量小于人数,要分小点
else
high=mid;
}
printf("%.4lf\n",mid);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: